package jcm.gui;
import jcm.*;
import jcm.tls.*;


import java.awt.*;

public class legend extends iob {
	
	public curvelabel[] cl, ncl; 
	graph gr; 
	int legtop=2, legspace, x, y, w, h; 
	public boolean showable=true; 
	
	public legend(graph g) {
		gr=g; owner=gr; 
		register(); 
	}
	
	public void newcurves() {
		try {
			if (cl==null || cl.length<gr.ncurves) ncl=new curvelabel[gr.ncurves]; 
			for (int n=0; n<gr.ncurves; n++) {
				if (cl==null || n>=cl.length || cl[n]==null) ncl[n]=new curvelabel(this, n); 
				else {
					if (!cl[n].name.equals(gr.curvename[n])) {	cl[n].color=gr.curvecolor[n]; cl[n].labelkey=gr.curvename[n]; cl[n].name=gr.curvename[n]; }
					ncl[n]=cl[n]; 
				}
			}
			cl=ncl; 
			//		for (int i=0; i<cl.length; i++) cl[i].setinteractions();
		} catch (Exception e) { debug(e); }
	}
	
	public void setinteractions() {
		try {
			setaffectedby(gr.pansetup); 
			setaffectedby(gr); 
			output=showable && gr.output && (popob.showcontrols.istrue() || gr.alwayscontrols()); 
		} catch (Exception e) {	debug(e); }
	}
	
	public void resize(int x, int y, int w, int h) {
		this.x=x; this.y=y; this.w=w; this.h=h; 
		int n2=(gr.stacked.istrue() && !gr.reversed ? gr.ncurves : -1); 
		legspace=((h-legtop)/gr.ncurves); if (legspace>16) legspace=16; 
		for (int n=0; n<gr.ncurves; n++) {
			n2+=(gr.curveoutput[n] ? (gr.stacked.istrue() && !gr.reversed ? -1 : 1):  0) ; 
			cl[n].resize(x+2, y+legtop+legspace*(n2), w-4, legspace-2); 
		}
	}
	
	public void postcalc() {	gr.clearRect(x,y,w,h); }
	
} //end class
//********************************************
	
class curvelabel extends popob {
	
	int n; legend l; 
	
	curvelabel (legend l, int n)	{	this.l = l; this.n=n; owner=l.gr; holder=l.gr; color=l.gr.curvecolor[n]; labelkey=l.gr.curvename[n]; name=labelkey; register(); }
	
	public void setinteractions() {
		setaffectedby(l); 
		output= l.output && n<l.gr.ncurves && l.gr.curveoutput[n]; //but how ensure this comes after graph interactions??
	}
	
	void draw(Graphics g) {
		g.setColor(color); g.fillRect(x, y, 14, h); 
		g.setColor(Color.black); g.setFont(smallfont); 
		g.drawString(labinf.getshort(labelkey), x+16, y+h-2); 
	} //end draw
	
}
