//Main caclulation loop through modules, 
//also calls other iobs' effects

package jcm;

import jcm.mod.*;

public class loop implements modlist {
	
	//***********************************
	public static boolean
		ready=false, inmainloop=false,
		repeat=false, //used for iteration
		calcfutureonly=false, //affects both pans and mods -may be set true by controls
		checkmemory=false; 
	
	public static param checkperform=new param("loopinfo", false); 
	
	public static iob ai(int i) {	return (iob)(iob.alliobs.elementAt(i)); } //just a shortcut
	public static int ni() {	return iob.alliobs.size(); }
	
	static long inttime=0, tottime=0, oldtime=0, newtime=0, timediff=0; 
	static String info=""; 
	public static iob itc, itn; //for iteration
	
	//*****************
	//MAIN CALCULATION LOOP
	
	public static void gowithin() {	inmainloop=false; go(); }
	//public static void go() { go(true); }
	
	static int i; //static so iob.dispose can adjust this from within loop!
	static iob aio; 
	
	static void iobloop(int stage) {
		for (i=0; i<ni(); i++) if (ai(i).needed && ai(i).changed && !ai(i).skip) {
			try {
				aio=ai(i).owner; if (aio!=ai(i)) switch (stage) {
					case 0: aio.preinterac(ai(i)); break; 
					case 1: aio.precalc(ai(i)); break; 
					case 2:; break; //modloop
					case 3: aio.postcalc(ai(i)); break; 
					case 4: aio.mainplot(ai(i)); break; 
					case 5: aio.postplot(ai(i)); break; 
				}
			} catch (RuntimeException e) {	catcher (e, stage, ai(i), true); }
			try {
				switch (stage) {
					case 0: ai(i).preinterac(); break; 
					case 1: ai(i).precalc(); break; 
					case 2:; break; //modloop
					case 3: ai(i).postcalc(); break; 
					case 4: ai(i).mainplot(); break; 
					case 5: ai(i).postplot(); break; 
				}
			} catch (RuntimeException e) {	catcher (e, stage, ai(i), false); }
			if (checkperform.istrue()) checktimespent(ai(i)); 
		}
	}
	
	static void catcher(RuntimeException e, int stage, iob i, boolean owneff) {
		iob.debug("runtime exception in loop stage "+stage+" "+i.owner.name+(owneff ? " effectof " : ".")+i.name+" => "+e); e.printStackTrace(); 
	}
	
	static boolean[] moderr=new boolean[nmods]; //to avoid 550 error reports if error in calcstep
	
	public static void go() {
		
		if (!inmainloop) {
			
			inmainloop=true; 
			//calcfutureonly=false; //temporary fix
			int startyear=(calcfutureonly ? 2000 : 1750); 
			if (checkperform.istrue()) startcheckperform(); 
			
			iobloop(0); //preinterac
			
			if (checkperform.istrue()) inttime=System.currentTimeMillis(); 
			
			if (repeat) iob.setchangedifneeded(itc, itn); 
			else iob.setallinteractions(); 
			
			if (checkperform.istrue()) inttime= System.currentTimeMillis() - inttime; 
			
			iobloop(1); //precalc
			
			//main loop of modules through timesteps
			for (int m=0; m<nmods; m++) moderr[m]=false; 
			for (int ns=(startyear-time.gsy); ns<=time.glos; ns++) {
				for (int m=0; m<nmods; m++) if (mod[m].needed && mod[m].changed){
					try {
						if (ns==(startyear-time.gsy)) mod[m].startstate(startyear); 
						mod[m].calcstep(ns); 
						if ((ns+time.gsy)==1999) mod[m].save99(); 
						if (checkperform.istrue()) checktimespent(mod[m]); 
					} catch (RuntimeException e) {	if (!moderr[m]) {	moderr[m]=true; catcher (e, 2000+ns, mod[m], false); }}
				}
			}
			
			iobloop(3); //postcalc
			iobloop(4); //mainplot
			iobloop(5); //postplot
			
			for (int i=0; i<ni(); i++) if (ai(i).needed && ai(i).changed && !ai(i).skip) 	ai(i).changed=false; //it's done now
			
			if (checkperform.istrue()) reporttimespent(); 
			
			if (checkmemory) info=("memory: free="+(int)(100.0*Runtime.getRuntime().freeMemory()/Runtime.getRuntime().totalMemory())+"%"); 
			
			System.gc(); //force garbage collect
			
			if (checkmemory) iob.debug(info+" after-gc= "+(int)(100.0*Runtime.getRuntime().freeMemory()/Runtime.getRuntime().totalMemory())+"%"); 
			
			calcfutureonly=false; 
			inmainloop=false; 
		}
		if (repeat) go(); 
	} //end mainloop
	
	//***************************************************
	//PERFORMANCE
	
	
	static void startcheckperform() {
		oldtime=System.currentTimeMillis(); tottime=oldtime; 
		for (int i=0; i<ni(); i++) ai(i).timespent=0; 
	}
	
	static void checktimespent(iob i) {
		newtime=System.currentTimeMillis(); 
		i.timespent+=newtime-oldtime; 
		oldtime=newtime; 
		if (i.timespent==0) i.timespent=-1; //so report
	}
	
	static void reporttimespent()  {
		tottime=System.currentTimeMillis()-tottime; 
		info="LOOP (time /ms)  total: "+tottime+ " interactions: "+inttime+" "; 
		for (int i=0; i<ni(); i++) 	if (ai(i).timespent!=0) {
			info+=( (ai(i).owner.getname()==ai(i).name ? "" : ai(i).owner.getname()+".") + ai(i).name+": "+ai(i).timespent+" "); 
		}
		iob.debug(info); 
		startcheckperform(); 
	}
	
	//************************************************
} //end modloop class
	
	
