package jcm.pan;
import jcm.*;
import jcm.mod.*;
import jcm.tls.*;
import jcm.gui.*;
import java.awt.*;

public class flowchart extends jcmpanel {
	
	module[] mod={
		oghga, carboncycle, radfor,
			heatflux, sealevel, regcli,
			sres, kyoto, mitigation,
			regshares, people,
			responsibility, costs
	}; 
	
	int[][] modpos={
		{	10, 20}, {	10, 64}, {	24, 90},
		{	50, 90}, {	80, 90}, {	90, 80},
		{	30, 10}, {	40, 30}, {	50, 50},
		{	58, 06}, {	72, 22},
		{	70, 55}, {	90, 45}
	}; 
	
	public boolean indoc() {	return false; }
	
	//public boolean needtoflow=true;
	Polygon[] po=new Polygon[100]; int na=0; //space for 100 arrows
	Color[] co=new Color[100]; 
	int[] x=new int[100], y=new int[100]; 
	int lp, lm=mod.length, mw, mh; double sfx, sfy; 
	title[] modpop=new title[lm]; 
	jcmpanel[] pan; 
	
	//*************************
	
	public void setinteractions() {
		for (int m=0; m<lm; m++) setaffectedby(mod[m], mod[m].needed); super.setinteractions(); 
	}
	
	public void setup() {
		super.setup(); 
		clearRect(0,tmh,panw,panh-tmh); 
		pan=holder.cpl.pan; 
		lp=pan.length; //if (lp>9) lp-=1; //avoid arrows pointing to flowchart itself!
		sfx=panw/100.0; sfy=(panh-tmh)/100.0; 
		for (int i=0; i<lm; i++) {	x[i]=(int)(modpos[i][0]*sfx); y[i]=(int)(modpos[i][1]*sfy)+tmh; if (modpop[i]==null) modpop[i]=new title(mod[i], this); modpop[i].setpos(x[i], y[i]); }
		for (int i=0; i<lp; i++) {	x[i+lm]=pan[i].panx+ pan[i].panw/2 - panx; y[i+lm]=pan[i].pany+ pan[i].panh/2 - pany; }
	} //end arrange
	
	
	//*************************
	
	void check(iob a, iob b, int i, int j) {
		//debug("check "+a.name+" < "+b.name+" : "+a.affectedby(b));
		if (a.affectedby(b) && !(a==this)) {
			co[na]=(a.needed && b.changed) ? red : yellow; 
			int off=(j>i ? 4 : -4); 
			arrow( x[j] +off, y[j] +off, x[i] +off, y[i] +off); 
			na++; 
		}
	}
	
	public void precalc() {
		na=0; 
		for (int i=0; i<lp; i++) for (int j=0; j<lm; j++) check(pan[i].bufi ,mod[j], i+lm, j); 
		for (int i=0; i<lm; i++)  for (int j=0; j<lm; j++) check(mod[i],mod[j], i, j); 
	}
	
	//overwrite this to avoid clip
	public Graphics getGraphics() {
		if (this==holder.cpl.central) {	Graphics g=holder.getGraphics().create(); g.translate(panx, pany); return g; }
		else return super.getGraphics(); 
	}
	
	public void postplot() {
		Graphics g=getGraphics(); 
		for (int a=0; a<na; a++) {
			g.setColor(co[a]); 
			g.fillPolygon(po[a]); 
		}
		g.dispose(); 
	}
	
	void arrow(int x1, int y1, int x2, int y2)  {
		po[na]=new Polygon(); 
		
		double ha=Math.PI/8.0, hl=24.0, aw=2.5; 
		double dx=x2-x1, dy=y2-y1, th=Math.atan(dy/dx); 
		if (dx<0) th+=Math.PI; 
		
		int acth=(int)(aw*Math.cos(th)), asth=(int)(aw*Math.sin(th)); 
		int hcth=(int)(0.6*hl*Math.cos(th)), hsth=(int)(0.5*hl*Math.sin(th)); 
		
		po[na].addPoint( x1+2*hcth -asth, y1+2*hsth+acth ); 
		po[na].addPoint( x1+2*hcth +asth, y1+2*hsth-acth ); 
		po[na].addPoint( x2+asth -3*hcth, y2-acth -3*hsth ); 
		po[na].addPoint( (x2 -2*hcth) -(int)(hl*Math.cos(th+ha)), (y2 -2*hsth)-(int)(hl*Math.sin(th+ha)) ); 
		po[na].addPoint( (x2 -2*hcth), (y2 -2*hsth) ); 
		po[na].addPoint( (x2 -2*hcth)-(int)(hl*Math.cos(th-ha)), (y2 -2*hsth)-(int)(hl*Math.sin(th-ha)) ); 
		po[na].addPoint( x2-asth -3*hcth, y2+acth -3*hsth ); 
	} //end arrow
	
} //end flowchart

//	public Point getloc(module m) {	for (int i=0; i<lm; i++) if(m==mod[i]) return new Point(x[i],y[i]); return null; }
//		mw=45; mh=16; 
		
		//		for (int i=0; i<lm; i++) modname(g, i, black); //if (mod[i]==iob.startchanged) g.setColor(red); else
	/*
	void modname (Graphics g, int i, Color c) {
	g.setFont(normalfont);
	g.setColor(c);
	g.drawString(mod[i].name, x[i]-mw/2, y[i]+mh/2+2);
	g.drawString(mod[i].name, x[i]-mw/2+1, y[i]+mh/2+2);
	}
	*/
	/*
	//call help page for modules
	public boolean handleEvent(Event e) {
		if (e.id==Event.MOUSE_DOWN && !mainapp.notapplet)  jcm.tls.showwebpage.showhelp(search(e.x, e.y)); 
		if 	(e.id==Event.MOUSE_MOVE) search(e.x, e.y); 
		return super.handleEvent(e); 
	}
	*/
/*	iob search(int ex, int ey) {
		int i; search: for (i=0; i<lm; i++) {
			int width=getGraphics().getFontMetrics(normalfont).stringWidth(mod[i].name); 
			if (ex>(x[i]-mw/2) && ex<(x[i]+width-mw/2) && ey>(2+y[i]-mh/2) && ey<(2+y[i]+mh/2) ) {
				modname(getGraphics(), i, red); 
				return mod[i]; 
			}
			else modname(getGraphics(), i, black); 
			//String filename="doc/"+mod[i].getClass().getName().replace(".".charAt(0),"/".charAt(0))+".html";
		}
		return(this); 
	}
*/	
